#include <RobotController.h>

#define STATE_STOP  0
#define STATE_FAST_FORWARD 1
#define STATE_FORWARD 2
#define STATE_FAST_BACKWARDS 3
#define STATE_BACKWARDS  4
#define STATE_RIGHT 5
#define STATE_LEFT 6
#define STATE_BORDER 7

void vBorder(int nV1, int nT1, int nV2, int nT2) {
  Serial.println("entro vBorder");
  vMotion(nV1, nV1);
  delay (nT1);
  vMotion(nV2, nV2);
  delay (nT2);
  Serial.println("surto vBorder");
}

void vRunState(byte byCS) {
  switch (byCS) {
    case STATE_STOP: vMotion(0, 0);
      break;
    case STATE_FAST_FORWARD: vMotion(255, 255);
      break;
    case STATE_FORWARD: vMotion(127, 127);
      break;
    case STATE_RIGHT: vMotion(127, 30);
      break;
    case STATE_LEFT: vMotion(30, 127);
      break;
    case STATE_BORDER: vBorder(127, 200, -127, 200);
      break;

  }
}

void setup() {
  Serial.begin(115200);
  RobotBegin();
}

void loop() {
  bool bBR, bBL, bFSL, bFL, bFC, bFR, bFSR;
  static unsigned long int ulLastMillis = millis(), n = STATE_STOP;
  unsigned long int ulNow = millis();
  unsigned long int ulDif = ulNow - ulLastMillis;

  vIR(&bBR, &bBL, &bFSL, &bFL, &bFC, &bFR, &bFSR);

  if (ulDif > 2000) {
    ulLastMillis = ulNow;
    switch (n) {
      case STATE_STOP: n = STATE_FORWARD;
        Serial.println("STATE_FORWARD");
        break;
      case STATE_FORWARD: n = STATE_BORDER;
        Serial.println("STATE_BORDER");
        break;
      case STATE_BORDER: n = STATE_STOP;
        Serial.println("STATE_STOP");
        break;
    }

  }
  vRunState(n);

}
